/* RAMESH KRISHNAN
   HW1

 PROGRAM DESIGN:

   Requirements: Program Objective: Calculator

		 -Shall have four real registers and four integer registers
		 -Shall allow the user to manipulate these registers (load,
		  clear, move between them)
		 -Shall allow arithmetic (+,-,*,/,power and square root)
		 -Shall check user input carefully


     Functional Decomposition:

   1. Define 4 integer and 4 real registers -Create a name for them
					    -Reserve memory for them
					    -Initialize them

   2. Obtain a mode to work with   -Get the mode
				   -Verify that is either integer or real

   3. Obtain the operation to execute -Display options to user and current
				       register values
				      -Ask the user and validate input

   4. Perform operation -Get the register names and values according to
			 the operation
			-Validate input
			-Execute the operation



   Sequence and hierarchy of functions:


	     Define Registers
		   |
		 Obtain a Mode
		   |
	  -->Obtain operation---->Display Mode, Options, Registers status
	 |                   |              |
	 |                   |   Get operation and Validate input until
	 |                   |   it is OK  |
	 |                   |___|         |
	 |                                 |
	 |								   |
	 |								   |
	 |								   |
	 |								   |
	  ----------------------Perform Operation---Depending on operation for each register
								   involved(load,clear,move):
							  |-> -Get name and validate name
							  |   -Get value and validate it
							  |_________________|




	Functions


   1. In Main:Defining and Initialising Registers
	  The registers A,B,C,D integer and real will be initialized in 0.

   2. Function Name: get_mode
	  Outputs     : returns int value of the mode chosen
	  What it does: gets the mode which will be 1 for integer mode and 2 for
	  real mode.


   3. Function Name: display_operation
	  Inputs       : the mode chosen and the registers A,B,C and D (i and r)
	  Outputs      : the operation chosen
	  What it does : It will show the user the current mode, registers status
	  operations available. The operations offered
	  will be as follows:
		   Load any register
		   Clear any register
		   Move between any two registers
		   Add      (A+B -> C) only
		   Subtract (A-B -> C) only
		   Multiply (A*B -> C) only
		   Divide   (A/B -> quotient C, remainder D) only
		   Square Root    (Sq Root of A -> C) only
		   Raise to Power (A to power in B -> C) only
		   Quit program


   4. Function Name: perform_operation
	  Inputs: the mode and operation chosen as well as the registers A,B,C
		  and D (real and integer
	  Outputs: the registers A,B,C and D integer and real
	  What it does: Given the operation (and mode) chosen in 3., this function
	  will perform it. In order to do so, a function will be created for each
	  operation available. They will be as follows:

	 -Function Name:loadint and loadreal.
	  Input        :depending on mode chosen,will pass by reference the registers.
	  Output       :The the registers with the value.
	  What it does :it loads register A,B,C,D after validating input


	  -Function name: ClearInt and ClearReal
	   Inputs: mode and registers A,B,C and D real and integer
	   Outputs: registers A,B,C and D real and integer
	   What it does: will get the name of the register to clear and will perform
	the clear after validating the name.

	  -Function name: MoveInt and MoveReal
	   Inputs: mode and registers A,B,C and D real and integer
	   Outputs: registers A,B,C and D real and integer
	   What it does: will get the names of the registers to move from and to.
	Then, it will perform the move after validating the names.

	  -Function name: Addint,Addreal,Subint,Subreal,Multint,Multreal,Divint
		Divreal,Rootint,Rootreal,Powint,Powreal

	   Inputs: mode and registers A,B,C and D real and integer
	   Outputs: registers A,B,C and D real and integer
	   What they do: they will execute the operations specified in the
	requirements using the registers already initialized and/or loaded
	   *Note: For the case of power, the program will finish for powers too
		  high. I will assume this as a non common case.

	  Since depending on the mode an integer or real number has to be entered,
	  there should be also functions that verify the input according to type
	  required. They will be used by the functions above to get valid values
	  and names. They are as follows:

	  -Function Name: get_reg
	   Outputs      : the name of the register chosen
	   What it does : it will obtain a valid name of a register

	  -Function Name: chkint and chkreal
	   Inputs: mode, name of register and registers A,B,C and D real and integer
	   Outputs: registers A,B,C and D real and integer
	   What it does : it will obtain a valid value for an integer if the mode
	is integer or a valid value for a real if the mode is a real. In order
	to do so the entered value will be read in a string and then it will
	be parsed to varify it and transform it to a number. This transformation
	will be done using functions from the libraries available (atof and atoi)

	  -Function Name: chk
	   Inputs:character pointer and count
	   OUtput:returns count value
	   What it does:It checks whether the user has input more than one decimal
	   points.

	  -Function Name:overwrt both for real and int
	   Inputs:Source and Destination register values
	   Output:gives a return based on whether the register is empty or has a
	   value.




*/

 #include<stdio.h>
 #include<math.h>
 #include<conio.h>
 #include<ctype.h>
 #include<stdlib.h>
 #include<string.h>
 #include<iostream.h>
   void program_info();
   int get_mode();

   char display_op_int(int*,int*,int*,int* );
   char display_op_real(float*,float*,float*,float*);

//  void user_op(char*,int*,int*,int*,int*,float*,float*,float*,float*);

   char chk_reg();
   int chk(char*,int*);

   void loadint(int*,int*,int*,int*);
   void loadreal(float*,float*,float*,float*);

   int chkint();
   float chkreal();
   int confirm();

   void overwrt(int*,int);
   void overwrt(float*,float);

   void moveint(int*,int*,int*,int*);
   void movereal(float*,float*,float*,float*);

   void clearint(int*,int*,int*,int*);
   void clearreal(float*,float*,float*,float*);

   void addint(int*,int*,int*);
   void subint(int*,int*,int*);
   void multint(int*,int*,int*);
   void divint(int*,int*,int*,int*);
   void powint(int*,int*,int*);
   void rootint(int*,int*,int*);

   void addreal(float*,float*,float*);
   void subreal(float*,float*,float*);
   void multreal(float*,float*,float*);
   void divreal(float*,float*,float*);
   void powreal(float*,float*,float*);
   void rootreal(float*,float*);




	 main()

	 {
	 clrscr();
	 int *ai,*bi,*ci,*di;
	 *ai=0,*bi = 0,*ci = 0,*di = 0;
	 float *ar,*br,*cr,*dr;
	 *ar = 0.0,*br = 0.0, *cr = 0.0, *dr = 0.0;

	 int mode,test,flag;


	 program_info();

	  mode=get_mode();

	 for(;;)
	 {

	   if (mode ==1)
	   {
		flag=0;
		for(;;)
		{

		 if (mode==2)
		   break;
		 char op = display_op_int(ai,bi,ci,di);
		 test =0;
		 switch (op)
		 {
		  case '+' :

		   addint(ai,bi,ci);
		  break;
		  case '-' :
		   subint(ai,bi,ci);
		  break;
		  case '*':
		   multint(ai,bi,ci);
		  break;
		  case '/':
		   divint(ai,bi,ci,di);
		  break;
		  case 'S':
		   rootint(ai,ci,di);
		  break;
		  case 'P' :
		   powint(ai,bi,ci);
		  break;
		  case 'L':
		   loadint(ai,bi,ci,di);
		  break;
		  case 'M':
		   moveint(ai,bi,ci,di);
		  break;
		  case 'Q':
		   flag=1;
		   test=1;
		   break;
//		   exit (1); //this is causing the computer to hang
		  case 'G':
		   mode=get_mode();
		  break;
		  case 'C':
			clearint(ai,bi,ci,di);
		  default:
			printf("\n\n Unknown Operation");
		  }

		 if (flag ==1 )
		     break;

		}


	     }


	  else if (mode==2)
	  {     flag=0;
		for(;;)
		{
		 if(mode==1)
		break;
		 char op = display_op_real(ar,br,cr,dr);
		 test=0;
		 switch (op)
		  {
		   case '+' :
		addreal(ar,br,cr);
		   break;
		   case '-' :
		subreal(ar,br,cr);
		   break;
		   case '*':
		multreal(ar,br,cr);
		   break;
		   case '/':
		divreal(ar,br,cr);
		   break;
		   case 'S':
		rootreal(ar,cr);
		   break;
		   case 'P' :
		powreal(ar,br,cr);
		   break;
		   case 'L':
		loadreal(ar,br,cr,dr);
		   break;
		   case 'M':
		movereal(ar,br,cr,dr);
		   break;
		   case 'Q':
		   test=1;
		   flag=1;
		   break;
//		exit (2);    this is causing the computer to hang
		   case 'G':
		mode=get_mode();
		   break;
		   case 'C':
		clearreal(ar,br,cr,dr);
		   break;
		   default:
		   printf("\n\n Unknown Operation");

		  }

		 if (flag ==1 )
		     break;
		}

	  }


	  if (test == 1)
		 break;
	  }

	return (0);

	}






   void program_info()
	{

	 printf("\n     This program is a calculator  ");
	 printf("\n  You have two modes:Integer mode OR Real mode  ");
	 printf("\n  We have four registers:A,B,C,D");
	 printf("\n  After you choose the mode you have various operations menu ");
	 printf("\n  The options are: ");
	 printf("\n  Addition : '+':Adds value in Register A and B and stores it in Register C");
	 printf("\n  Subtraction: '-':Subtracts value in Register B from Register A and stores it in Register C");
	 printf("\n  Multiplication:'*':Multiplies value in Register A and B and stores it in Register C");
	 printf("\n  Division:'\':Divides value in Register A by Register B and stores quotient in Register C and remainder(only for integer) in Register D ");
	 printf("\n  Power:'P':Power raises value in Register A to Register B and stores it in Register C ");
	 printf("\n  Sqroot:'S':Sqroot is root of value in Register A and stores it in Register C(for integer remainder is stored in Register D");
	 printf("\n  Load:'L':Loads the values in the registers");
	 printf("\n  Move:'M':MOves the values from one register to another");
	 printf("\n  Clear:'C':Clears the values stored in the register(sets it to 0)");
	 printf("\n  Change:'G':Changes mode ");
	 printf("\n  Quit:'Q':Quits the program");
	 printf("\n  NOTE::The characters for Power,Sqroot,Load,Move,Clear,Quit are all upper case letters");
	 printf("\n  NOTE:For real the output is given for 2 decimal places");

	 }




   int get_mode()
	{
	  int mod =0;
	  char mode;

	   for(;;)
	  {

	   printf("\n Enter mode of operation,'I' for integer\n");
	   printf("                           'R' for real\n");
	   mode =getch();

	   putchar(mode);
	   fflush(stdin);

		if (mode=='I'|| mode=='i')

		{
		 mod=1;
		 break;
		}
	   else if	(mode=='R'|| mode=='r')

		{
		 mod =2;
		 break;
		}

		printf("\n\nEnter a valid character\n");

	  }

	  return(mod);

	}









   char display_op_int(int* a,int* b,int* c,int *d)
   {
//  int status;
	 char ch;
	  for(;;)

	  {
	   printf("\nRegisterA=%d RegisterB=%d RegisterC=%d RegisterD=%d\n",*a,*b,*c,*d);


	   printf("\n  Enter + to add\n\n  Enter - to subtract\n\n  Enter * to multiply\n\n");
	   printf("\  Enter / to divide\n\n  Enter S for sqroot\n\n  Enter P for power\n\n");
	   printf("\  Enter L to load a value of register\n\n  Enter M to move value between registers\n\n ");
	   printf("\  Enter C to clear register\n\n  Enter G to change mode \n\n  Enter Q to quit program\n\n");

	   ch  = getch();

	   fflush(stdin);



	   if (ch=='+'||ch=='-'||ch=='*'||ch=='/'||ch=='S'||ch=='P'||ch=='M'||ch=='Q'||ch=='L'||ch=='C'||ch=='G')
	   break;




	   printf("\n You have entered an invalid character\n\n Enter again\n");

	   }


	return(ch);
	}








   char display_op_real(float* x,float* y,float* z,float* t)
   {
//  int status;
	  char ch;
	 for(;;)

	 {
	  printf("\n RegisterA=%-7.2f RegisterB=%-7.2f RegisterC=%-7.2f RegisterD=%-7.2f\n",*x,*y,*z,*t);



	   printf("  Enter + to add\n\n  Enter - to subtract\n\n  Enter * to multiply\n\n");
	   printf("\  Enter / to divide\n\n  Enter S for sqroot\n\n  Enter P for power\n\n");
	   printf("\  Enter L to load a value of register\n\n  Enter M to move value between registers\n\n ");
	   printf("\  Enter C to clear register\n\n  Enter G to change modes\n\n  Enter Q to quit program\n\n");

	   ch  = getch();

	   fflush(stdin);

	  if (ch=='+'||ch=='-'||ch=='*'||ch=='/'||ch=='S'||ch=='P'||ch=='M'||ch=='Q'||ch=='L'||ch=='C'||ch=='G')
	   break;




	   printf("\n You have entered an invalid character\n\n Enter again\n");

	   }


	return(ch);
	}







   int chkint()
   {
	int a;
	int blag=0,flag=0;
	char *s, strg[20];

	while (blag ==0)


	 {

	   flag =0;
	   printf("\n  Enter value\n");
	   printf("\n  You can enter upto 4 characters including sign in IRegister \n");
	   printf("\n  Example : 5678 , -567 \n");
	   cin >>strg;
	   s=strg;
	   fflush(stdin);
	   int len =strlen(strg);


	   while (flag ==0)
	   {

	  /* You do not need this statement because you are using scanf not getchar  */


	    if (*s=='-'|| (*s >= '0' && *s <= '9'))
	     {

	       while(len > 4)

		   {
		 printf("\n You have exceeded  value\n");
		 flag =1;
		 break;
	       }


	       s++;

	       if (*s == 0)

		{
		 a=atoi(strg);			/*       isdigit() */
		 flag=1;
		 blag=1;
		}


	      }

	   else

	     {


		 printf("Hey Bugger Invalid Entry\n");
		 printf("Press any key to continue\n");
		 getch();
		 flag =1;


	     }


	   }

	 }


	  return (a);
     }






	   float chkreal()
     {
	float a;
	int blag=0,flag=0;
	char *s, strg[20];

	 while (blag==0)

	 {
	  int count=0;
	  flag =0;
	  printf("\nEnter value\n");
	  printf("\nYou can enter upto 6 characters including sign and decimal in RRegister \n");
	  printf("\nExample : 5678.1 , -567.1 , 34.345, 5.6788 \n");
	  cin>>strg;
	  s=strg;
	  fflush(stdin);
	  int len =strlen(strg);


	  while (flag ==0)

	  {

	   if (*s == '-' || *s =='.' || (*s >= '0' && *s <= '9'))

	    {
	     flag= chk( s,&count);

	     while (len > 6)

		  {

		printf("\n You have exceded right value\n");
		flag =1;
		break;
	      }


		s++;
		if (*s == 0)
		{
		  a=atof(strg);			/*       isdigit() */
		  flag=1;
		  blag=1;
		}
	     }

	  else

	     {
		 printf("\nHey Bugger Invalid Entry\n");
		 printf("\nPress any key to continue\n");
		 getch();
		 flag=1;
	     }



	   }


	 }

	  return (a);

	 }



	 int chk(char* p,int* cnt)
	 {

	   int fl=0;

	   if (*p =='.')
	   {
		(*cnt)++;  /* deferencing count*/

	    if(*cnt ==2)
	      {

		if (*cnt == 2)

		 {

		  printf("\n You are entering too many decimal points\n");
		  fl =1;
	/*   count =0; */

		 }

	       }



	     }

	 return (fl);
	 }




	void addint(int *a,int* b,int* c)

	{

	 *c=*a+*b;

	}




	void subint(int *a,int *b,int *c)
	{

	 *c=*a-*b;
//     return (a - b);
	}




       void divint(int* a, int* b,int* c,int* d)
	{

	 *c=*a/(*b);
	 *d=*a%*b;
//   return (a/b);
	}




	  void multint(int* a,int* b,int* c)
	{
	  *c=(*a)*(*b);
//     return (a*b);
	}





      void rootint(int* a,int* c,int* d)
      {


	if (*a<0)

	 {
	  printf(" \n The value in Register A must be positive\n");
	  printf(" Press any key to continue\n");
	  getch();
	  return;

	  }

	  float p ;


	   p=sqrt(*a);
	   *c=int(p);
	  *d=(*a-((*c)*(*c)));

      }






   void powint(int* a,int* b,int* c)
	{
	  float p;
	  for (p=1;b>0;b--)
	     p=p*(*a);

	 if (p>100000l)
	   {
	    printf("\n overflow:value too large\n");
	    printf("Press any key to continue");
	    getch();
	    return;
	   }

	  *c=int(p);
	}




   void loadint(int* a,int* b,int* c,int* d)
    {
	for(;;)

	{

	 char rg=chk_reg();




	   printf("\n\nEnter the value you want to store in Register %c",rg,"\n");

		switch(rg)
		{
		  case 'A':
		  case 'a':

		   *a=chkint();
		   break;
		  case 'B':
		  case 'b':
			*b=chkint();
			break;
		  case 'C':
		  case 'c':
			*c=chkint();
			break;
		  case 'D':
		  case 'd':
			*d=chkint();

		 }

	    printf("\nIf you have finished entering value:Press F10\n");
	    printf("  To continue entering values        :Hit Enter\n");
	    int p=0;
	    while (p<=0)
		p=getch();
		  if (p==68)
		 break;
	  }


	}






   void moveint(int* a,int *b,int* c,int* d)


      {


	 printf("\n Enter the source register");
	 char sor=chk_reg();
	 printf("\n Enter the destination register");
	 char des=chk_reg();
	 int se,*de;


	  switch(sor)
		{
		  case 'A':
		  case 'a':
		   se=*a;

		   break;
		  case 'B':
		  case 'b':
		   se= *b;
		   break;
		  case 'C':
		  case 'c':
		   se=*c;
		   break;
		  case 'D':
		  case 'd':
			se=*d;

		 }

	 switch(des)

		{
		  case 'A':
		  case 'a':
			 de=a;

			   overwrt(de,se);
			 break;
		  case 'B':
		  case 'b':
			de=b;
			  overwrt(de,se);
			break;
		  case 'C':
		  case 'c':
			de=c;
			 overwrt(de,se);
			break;
		  case 'D':
		  case 'd':
			de=d;
			  overwrt(de,se);
		 }



	}


   void clearint(int* a,int* b,int* c,int* d)
    {

       printf("\n Enter the register name to clear\n");
       char s=chk_reg();

	 int se=0,*de;


	  switch(s)
		{
		  case 'A':
		  case 'a':

		   de=a;
			  overwrt(de,se);
		   break;
		  case 'B':
		  case 'b':
		    de=b;
			  overwrt(de,se);
		   break;
		  case 'C':
		  case 'c':
		   de=c;
		      overwrt(de,se);
		   break;
		  case 'D':
		  case 'd':
		   de=d;
		       overwrt(de,se);
		 }


      }



   void addreal(float* x, float* y,float* z)
     {

	  *z=*x+*y;
//	  return (x + y);
     }





   void subreal(float* x, float* y,float* z)
     {
	  *z=*x-*y;

//   return (x - y);
     }




   void divreal(float* x,float* y,float* z)
     {

	 *z=*x/(*y);


//   return (x/y);
     }





   void multreal(float* x,float* y,float* z)
     {
	 *z=(*x)*(*y);
//   return (x*y);
     }





   void rootreal(float* x,float* z)
     {

	 if (*x<0)

	 {
	  printf(" \n The value in Register A must be positive\n");
	  printf("Press any key to continue");
	  getch();
	  return;

	  }

	*z=sqrt(*x);
//	return z;
     }




   void powreal(float* x,float* y,float* z)
      {
	  double p;
	   if (*x<0)
		 {
		  int q=int(*y);
		   if (q!=*y)
			 {
			 cout<<endl<<"You cannot raise a negative number to a decimal";
			 cout<<"\nPress any key to continue";
			 getch();
			 return;
			 }
		  }

	   p=pow(*x,*y);
	   if (p> 10000000l)
	   {
	   printf("\n There is overflow:value too large\n");
	   return;
	   }
	   *z=float(p);
	   }






  void loadreal(float* a,float* b,float* c,float* d)
   {
	for(;;)
	{

	  char reg=chk_reg();




	   printf("\n\nEnter the value you want to store in Register %c\n",reg);

		switch(reg)
		{
		  case 'A':
		  case 'a':

		   *a=chkreal();
		   break;
		  case 'B':
		  case 'b':
			*b=chkreal();
			break;
		  case 'C':
		  case 'c':
			*c=chkreal();
			break;
		  case 'D':
		  case 'd':
			*d=chkreal();
		 }



	    printf("\nIf you have finished entering value:Press F10\n");
	    printf("  To continue entering values        :Hit Enter\n");
	    int p=0;
	    while (p<=0)
		p=getch();
	      if (p==68)
		 break;
	  }

	}


	void movereal(float* a,float *b,float* c,float* d)
	{
	 printf("\n Enter the source register");
	 char sor=chk_reg();
	 printf("\n Enter the destination register");
	 char des=chk_reg();
	 float se=0.0,*de;


	  switch(sor)
		{
		  case 'A':
		  case 'a':
		   se=*a;

		   break;
		  case 'B':
		  case 'b':
		   se= *b;
		   break;
		  case 'C':
		  case 'c':
		   se=*c;
		   break;
		  case 'D':
		  case 'd':
		   se=*d;

		 }

	 switch(des)
		{
		  case 'A':
		  case 'a':
			 de=a;


			  overwrt(de,se);
			break;
		  case 'B':
		  case 'b':
			de=b;
			  overwrt(de,se);
			break;
		  case 'C':
		  case 'c':
			de=c;
			 overwrt(de,se);
			break;
		  case 'D':
		  case 'd':
			de=d;
			  overwrt(de,se);
		 }

	   }





       void clearreal(float* a,float* b,float* c,float* d)
	   {

	 printf("\n Enter the register name to clear\n");
	 char s=chk_reg();

	 float se=0,*de;


	  switch(s)
		{
		  case 'A':
		  case 'a':

		   de=a;
		      overwrt(de,se);
		   break;
		  case 'B':
		  case 'b':
		    de=b;
		      overwrt(de,se);
		   break;
		  case 'C':
		  case 'c':
		   de=c;
		      overwrt(de,se);
		   break;
		  case 'D':
		  case 'd':
		   de=d;
		       overwrt(de,se);
		 }


	    }





	char chk_reg()
	{

	  char reg;
	  for(;;)

	 {
	   printf("\n\nEnter the Register  Name \n");
	   printf("\nValid names are: A,B,C,D \n");

	   reg=getch();
	   fflush(stdin);

	   if (reg=='A'||reg=='a'||reg=='B'||reg=='b'||reg=='C'||reg=='c'||reg=='D'||reg=='d')
		 break;

	   printf("\nInvalid register name: Enter again \n");

	  }

	 return(reg);
	}



     int confirm()
      {
	 int cfm=0;
	 for(;;)
	 {
	 printf("\n The register has value stored in it\n");
	 printf("\n To overwrite/clear value:Type Y \n");
	 printf("\n If not                  :Type N \n");
	 char c=getch();
	   if (c=='Y'||c=='y')
		  {
		   cfm=1;
		   break;
		  }
	   else if(c=='N'||c=='n')
		  {
		   cfm=2;
		   break;
			  }
	   else
		   printf("\n Invalid entry \n");
	 }

	return(cfm);
     }





	void overwrt(int* p,int q)
	{
	 int con=0;
	 if (*p != 0)
//			 printf("\n Overwrite value\n");
			  con=confirm();
			   if (con ==1)
				  *p=q;
	}





	void overwrt(float* p,float q)
	{
	   int con=0;
	   if (*p != 0)
//			 printf("\n Overwrite value\n");
			 con=confirm();
			   if (con ==1)
				  *p=q;
	}














